# EliteReworks (Beta Release)
This mod seeks to address the longstanding issues with Elite bulletsponge that have been around since the day RoR2 released into Early Access. Elite damage and HP multipliers are reduced, but their spawn cost is decreased and their abilities are more impactful. You might also start to see elite bosses earlier into runs now, due to their reduced cost.

Updates will probably slow since I don't have a lot of time to develop/test things, so feedback will be super helpful.
Open an issue on the GitHub or send me a DM if you have any thoughts.

All players need the mod.

# Current Balance Concerns
- How are the Celestine Beta changes? (Check the config to enable!)
- How does Overloading damage feel?
- Are Overloading projectiles actually able to hit you? Is the AOE too small?

# Changes
- **General:**
	- T1 Elites:
		- Cost reduced 6x -> 4.5x
		- HP reduced 4x -> 3x
		- Damage reduced 2x -> 1.5x
	- T2 Elites:
		- Cost reduced 36x -> 15x
		- HP reduced 18x -> 10x
		- Damage reduced 6x -> 3.5x
		
	*Vanilla elites are essentially 1shot HP sponges, with their abilities generally being an afterthought that doesn't really come into play when fighting them. This mod seeks to reduce elite tankiness and instead make their abilities more pronounced. Also to compensate for the lower HP, elites have had their spawn cost reduced, so they'll be able to spawn more frequently.*
	
	- Stun/Shock/Freeze now disables most passive elite effects.
	
		*This should allow melee survivors to fare better against elites with passive damage abilities without having to rely on i-frames.*

- **Glacial:**
	- Attacks have an AOE that slows for 3 seconds (think Behemoth, but slowing instead of damaging).
	
		*Vanilla Glacials pretty much don't do anything. This change should hopefully make them better at slowing players.*
		
- **Overloading:**
	- Shields removed.
	- Attacks scatter 5 lightning bombs nearby. Lightning bombs arc into the air and explode on contact with the ground/walls.
		- Deals 70% of the initial hit's damage.
	- Passively scatters 5 lightning bombs nearby every 6 seconds.
		- Damage is based on level for consistency.
	- Stun/Shock/Freeze disables the passive lightning bombs.
	
		*The main feature of vanilla Overloading is bosses healing half of their HP pool if you focus on something else for a bit. These changes are intended to shift Overloading enemies into being less about tanking, and more about chaotically spamming projectiles everywhere, hopefully leading to a more engaging experience when fighting them.*
		
- **Blazing:**
	- Fire trails damage now scales based on level, instead of damage.
	- Stun/Shock/Freeze disables the passive fire trail.
	
	*Fire trails are very unpredictable due to being scaled off of enemy damage. Some enemies won't do much damage, while others will melt you in a few ticks. This change makes Blazing trails consistent across all enemies, which should make them more predictable to fight as melee characters.*

- **Malachite:**
	- Malachites now have a passive anti-heal AOE.
	- Malachite spikes now deal 50% of your current HP.
	- Malachite spikes now apply Anti-Heal + Weaken for 8 seconds.
	- Stun/Shock/Freeze disables their passive spikes + anti-heal AOE.
	
	*Vanilla Malachites suck to fight. Their anti-heal is an interesting way of neutering the massive healing players can get from items, but it never really gets much use in practice since it requires you to get hit by one of their near instant-kill attacks to trigger it. These changes seek to make Malachites less about 1shotting, and more about denying heals. Malachites now have a passive anti-heal AOE around them to make sure that their anti-heal actually gets use, and their spikes act more like traps that slow players and keep them inside the AOE, rather than instant kill anti-melee landmines.*

- **Celestine (Beta):**
	- Disabled by default, must be enabled in the config.
		- Removed vanilla behavior.
		- Attaches to up to 3 nearby enemies.
			- Attached enemies gain +30% attack speed, +50% movement speed, and -25% cooldown reduction.
			- On death, they revive as a ghost and will continue to live on for up to 20s.
			- Killing a Celestine kills all their attached ghosts.
		- On-hit effect changed to -20 armor instead of slowing.

## Installation

Place EliteReworks.dll in /Risk of Rain 2/BepInEx/plugins/

## ChangeLog

- 0.1.5
	- Added a network check when adding the Elite ability handler components. Hopefully this should fix Overloading enemies sometimes spitting out tons of passive lighting projectiles.

- 0.1.4
	- T2 Elites
		- Damage reduced 4x -> 3.5x
		
	*4x damage seemed to bring them back into constant 1shot territory, so I'm putting it at a halfway point between the old 3x damage and the damage in the previous update.*
	
	- Glacial
		- Fixed slow duration being able to exceed 2.5s on attacks with a proc coefficient greater than 1.0 (Jellyfish).
	
	- Celestine (Beta)
		- No longer slows on-hit. Now just reduces armor by -20.
		- Reduced max active ghosts from 7 -> 3
		- Ghost lifetime reduced 30s -> 20s.
		- Attached enemy move speed increased 30% -> 50%.
		- Attached enemies now gain -25% cooldown reduction.
		
	*There were too many movement slows from too many different sources (Glacials, Malachite Spikes), so Celestines no longer slow on hit. Max ghost count has been cut down since it got out of hand really quickly (3 random Celestines in a crowd would turn into 21 ghosts). In exchange for a lower ghost count, ghosts now have increased stats. I wasn't sure how I'd go about with increasing their stats to make them more threatening, since simply increasing damage ends up being unfun and 1shotty, so I've tried reducing their cooldowns and boosting their move speed to make them more aggressive.*

- 0.1.3
	- Fixed Glacials not actually using blast falloff.

- 0.1.2
	- Celestine (Beta)
		- Tweaked visuals. Hoping this should improve readability.
			- Now, only Celestines show a particle effect (the warbanner icon).
			- Enemies attached to Celestines now have a red tint.
			- Celestine Ghosts now have a red tint.

	- Overloading
		- On-hit explosives now scatter randomly
		
	*With the lower blast radius, the bombs from on-hit attacks weren't really hitting their mark consistently. Randomizing their scatter pattern should help make them more of a threat, while their lowered blast radius from the earlier update should keep them dodgeable.*
		
	- Glacial
		- Duration reduced from 1s + 2s(proc) to 0.5s + 2s (proc)
		- Getting hit on the edge of the blast (>50% of the blast radius) now reduces slow duration by 50%.

- 0.1.1
	- Celestine (Beta)
		- Celestines now gain +30% attack speed and movement speed while controlling ghosts.
		- Celestines now show a particle effect while controlling ghosts. (this didn't work)
	
	*This should help with visiblity.*
	
	- Overloading
		- Passive damage increased 32 -> 36.
		
	*Felt that their passive damage is a bit too low considering how it's harder to get hit by lightning now. Let me know if this ends up being too high, or if it's not high enough.*
		
- 0.1.0
	- T2 Elites
		- Cost increased 12x -> 15x
		- HP increased 8x -> 10x
		- Damage increased 3x -> 4x
		
	*Felt T2 Elites were spawning too often, so I've upped their cost and increased their HP a bit to compensate. Damage has been increased since I felt they weren't threatening enough damagewise, but it's still considerably lower than their vanilla damage multiplier.*
		
	- Celestine (Beta)
		- Disabled by default, must be enabled in the config.
		- Removed vanilla behavior.
		- Attaches to up to 7 nearby enemies.
			- Attached enemies gain +30% attack speed and movement speed.
			- On death, they revive as a ghost and will continue to live on for up to 30s.
			- Killing a Celestine kills all their attached ghosts.
		- On-hit effect changed to Cripple (like Perfected elites)
			
	*Unsure about this, lemme know if this is any fun to fight, or if I need to go back to the drawing board on this one. Ideally I'd like to have a line or some sort of indicator to show which Celestine each enemy is connected to, but I have no clue how to network it. Thoughts would be greatly appreciated.*
		
	- Overloading
		- Increased passive lightning damage from 28 -> 32
		- Increased on-hit lightning damage from 50% -> 70%
		- Reduced on-hit lightning AOE from 5m -> 3m
		- Lightning bomb explosion noise reduced (now just makes a generic shock explosion sound effect).
		- Reworked cooldown behavior:
			- Overloading enemies have a stock of 20 bombs that fully recharge over 1.6s
			- Attack bomb count scales off of proc coefficient, and uses up bombs from the stock.
		
	*Overloading Lightning in its current state essentially is just low but guaranteed free damage to things nearby. Experimenting with making it stronger but with a tighter AOE so that it's more based around dodging. Reworked cooldown behavior is mainly there to make Overloading Templars and other rapid-hit enemies look less jank, the amount of bombs they can put out should be about the same. Thoughts on these changes would be greatly appreciated.*
		
	- Blazing
		- Increased fire trail damage from 18/s -> 21/s
		
	- Glacial
		- Slow duration partially scales with proc coefficient now.
			- Slow is guaranteed to last for at least 1 second, while the remaining 2 seconds will scale off of proc coefficient.

	*Glacial wisps were being a bit too oppressive, being able to shotgun blast in your general direction and slow you for 3 seconds.*

- 0.0.6
	- Fixed nullref spam with latest version of CHEF.

- 0.0.5
	- Fixed Glacial Elites stunlocking you when ZetAspects is installed.
	- Fixed a bug where you become unable to proc Overloading's effect when using Wake of Vultures (?)

- 0.0.4
	- Overloading passive damage reduced 32 -> 28
	- Overloading on-hit damage reduced 80% -> 50%

- 0.0.3
	- Fixed a bug where Malachite and Overloading enemies could sometimes lose their passive effects.
	- Overloading disable shield config option can now be enabled when Overloading Changes are disabled.
	- Overloading passive damage increased 24 -> 32
	- Overloading on-hit damage increased 50% -> 80%
	- Overloading on-hit bomb count now does not scale downwards with proc coefficient.
	- Overloading on-hit now has a 0.33s cooldown per trigger. This may be raised in the future if it is still lagging a lot.
	- Malachite antiheal AOE radius reduced 25m -> 22m (for reference, Celestine is 30m)
	- Malachite antiheal AOE now has a subtle range indicator.
	- Added config option to hide Celestine bubbles (disabled by default).

- 0.0.2
	- Fixed an incorrect description in the readme.

- 0.0.1 ``Initial Release``